# mypy-boto3-ecr-public

[![PyPI - mypy-boto3-ecr-public](https://img.shields.io/pypi/v/mypy-boto3-ecr-public.svg?color=blue)](https://pypi.org/project/mypy-boto3-ecr-public)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-ecr-public.svg?color=blue)](https://pypi.org/project/mypy-boto3-ecr-public)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.ECRPublic 1.17.13](https://boto3.amazonaws.com/v1/documentation/api/1.17.13/reference/services/ecr-public.html#ECRPublic) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.4.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-ecr-public](#mypy-boto3-ecr-public)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `ECRPublic` service.

```bash
python -m pip install boto3-stubs[ecr-public]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[ecr-public]` in your environment: `python -m pip install 'boto3-stubs[ecr-public]'`

Both type checking and auto-complete should work for `ECRPublic` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[ecr-public]` in your environment: `python -m pip install 'boto3-stubs[ecr-public]'`

Both type checking and auto-complete should work for `ECRPublic` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[ecr-public]` in your environment: `python -m pip install 'boto3-stubs[ecr-public]'`
- Run `mypy` as usual

Type checking should work for `ECRPublic` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[ecr-public]` in your environment: `python -m pip install 'boto3-stubs[ecr-public]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ECRPublic` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`ECRPublicClient` provides annotations for `boto3.client("ecr-public")`.

```python
import boto3

from mypy_boto3_ecr_public import ECRPublicClient

client: ECRPublicClient = boto3.client("ecr-public")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ECRPublicClient = session.client("ecr-public")
```

### Paginators annotations

`mypy_boto3_ecr_public.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_ecr_public import ECRPublicClient
from mypy_boto3_ecr_public.paginator import (
    DescribeImageTagsPaginator,
    DescribeImagesPaginator,
    DescribeRegistriesPaginator,
    DescribeRepositoriesPaginator,
)

client: ECRPublicClient = boto3.client("ecr-public")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_image_tags_paginator: DescribeImageTagsPaginator = client.get_paginator("describe_image_tags")
describe_images_paginator: DescribeImagesPaginator = client.get_paginator("describe_images")
describe_registries_paginator: DescribeRegistriesPaginator = client.get_paginator("describe_registries")
describe_repositories_paginator: DescribeRepositoriesPaginator = client.get_paginator("describe_repositories")
```







### Typed dictionations

`mypy_boto3_ecr_public.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_ecr_public.type_defs import (
    AuthorizationDataTypeDef,
    ImageDetailTypeDef,
    ImageFailureTypeDef,
    ImageIdentifierTypeDef,
    ImageTagDetailTypeDef,
    ImageTypeDef,
    LayerFailureTypeDef,
    LayerTypeDef,
    ReferencedImageDetailTypeDef,
    RegistryAliasTypeDef,
    RegistryCatalogDataTypeDef,
    RegistryTypeDef,
    RepositoryCatalogDataTypeDef,
    RepositoryTypeDef,
    BatchCheckLayerAvailabilityResponseTypeDef,
    BatchDeleteImageResponseTypeDef,
    CompleteLayerUploadResponseTypeDef,
    CreateRepositoryResponseTypeDef,
    DeleteRepositoryPolicyResponseTypeDef,
    DeleteRepositoryResponseTypeDef,
    DescribeImageTagsResponseTypeDef,
    DescribeImagesResponseTypeDef,
    DescribeRegistriesResponseTypeDef,
    DescribeRepositoriesResponseTypeDef,
    GetAuthorizationTokenResponseTypeDef,
    GetRegistryCatalogDataResponseTypeDef,
    GetRepositoryCatalogDataResponseTypeDef,
    GetRepositoryPolicyResponseTypeDef,
    InitiateLayerUploadResponseTypeDef,
    PaginatorConfigTypeDef,
    PutImageResponseTypeDef,
    PutRegistryCatalogDataResponseTypeDef,
    PutRepositoryCatalogDataResponseTypeDef,
    RepositoryCatalogDataInputTypeDef,
    SetRepositoryPolicyResponseTypeDef,
    UploadLayerPartResponseTypeDef,
)

def get_structure() -> AuthorizationDataTypeDef:
    return {
      ...
    }
```
